<template>
  <div class="order-tracking__container details" v-if="order.route">
    <h2>Детали заказа</h2>

    <div class="details__params">
      <p>Маршрут: {{order.route.from}} → {{order.route.to}}</p>
      <div class="details__params-items">
        <div class="details__params-item">
          <ob-input
            label="№ договора в Обоз"
            :value="order.contractNumber"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Внутренний № заказа по системе Заказчика"
            placeholder="Внутренний № заказа по системе Заказчика"
            :value="order.externalNumber"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-date-picker
            :value="order.createdAt"
            label="Дата и время создания заказа"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Заказчик"
            placeholder="Заказчик"
            :value="order.clientName"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Ответственный логист"
            placeholder="Ответственный логист"
            :value="order.logistTitle"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Контактный телефон"
            placeholder="Контактный телефон"
            :value="order.logistPhone"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Исполнитель"
            placeholder="Исполнитель"
            :value="order.executorName"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Ответственный логист Исполнителя"
            placeholder="Ответственный логист Исполнителя"
            :value="order.contactUserTitle"
            disabled
          />
        </div>
        <div class="details__params-item">
          <ob-input
            label="Контактный телефон"
            placeholder="Контактный телефон"
            :value="order.contactUserPhone"
            disabled
          />
        </div>
      </div>

      <div class="details__params-comment">
        <ob-text-area
          label="Комментарий"
          :value="order.comment"
          disabled
        />
      </div>
    </div>

    <div class="details__services">
      <h2>
        Услуги трекинга
        <span>по договору <a href="#">{{order.contractNumber}}</a> от {{order.contractDate | date}}</span>
      </h2>

      <div class="details__services-items">
        <div class="details__services-item">
          <h3>
            Базовые услуги
            <span><strong>{{new Intl.NumberFormat('ru-RU').format(Math.round(order.baseServices.price / 100))}} ₽</strong> с НДС</span>
          </h3>

          <div class="table-block">
            <div class="table-block__header">
              <i class="icon pin"/>
              {{order.baseServiceGeography.from}} → {{order.baseServiceGeography.to}}
            </div>
            <ob-table
              :items="[order.baseServices]"
              :columns="columns"
              :functional-panel="false"
              :footerDisabled="true"
              data-qa="orderDetailsTable"
              ref="obTableDetails"
            />
          </div>
        </div>

        <div class="details__services-item">
          <h3>
            Дополнительные услуги
            <span><strong>{{ new Intl.NumberFormat('ru-RU').format(Math.round(order.additionalServicePrice / 100)) }} ₽</strong> с НДС</span>
          </h3>

          <div class="table-block">
            <div class="table-block__header">
              <i class="icon pin"/>
              {{order.additionalServiceGeography.from}} → {{order.additionalServiceGeography.to}}
            </div>
            <ob-table
              :items="order.additionalServices"
              :columns="columns"
              :functional-panel="false"
              :footerDisabled="true"
              data-qa="orderDetailsTable"
              ref="obTableDetails"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { formatNumber } from 'common-components/src/helpers/common'
  import api from '@/api';

  import obInput from 'common-components/src/obComponents/obInput';
  import obDatePicker from 'common-components/src/obComponents/obDatePickerConstructor';
  import obTextArea from 'common-components/src/obComponents/obTextarea';
  import obTable from 'common-components/src/obComponents/obTable';
  export default {
    name: 'trackicngOrderDetails',

    props: {
      uuid: {
        type: String,
        required: true
      }
    },

    components: {
      obInput,
      obDatePicker,
      obTextArea,
      obTable,
    },

    async created() {
      try {
        const details = await api.orders.getTrackingOrderDetails(this.$route.params.id);

        if (details) {
          this.order = { ...details };
        }
      } catch (e) {
        console.error(e);
      }
    },

    data() {
      return {
        order: {},
      }
    },

    computed: {
      columns () {
        return [
          {
            title: 'наименование',
            key: 'title',
            width: 300
          },
          {
            title: 'География',
            key: 'route',
            html: (data) => `${data.route?.from} → ${data.route?.to}`
          },
          {
            title: 'НДС',
            key: 'vat',
            html: (data) => data.vat ? `${formatNumber(data.vat)}%` : '-'
          },
          {
            title: 'Единица измерения',
            key: 'serviceUnitTitle',
            html: (data) => data.serviceUnitTitle ? data.serviceUnitTitle : '-'
          },
          {
            title: 'кол-во',
            key: 'count',
            html: (data) => data.count ? formatNumber(data.count) : '-'
          },
          {
            title: 'сумма с НДС, ₽',
            key: 'price',
            html: (data) => data.price ? formatNumber(data.price / 100) : '-'
          }
        ]
      }
    },

    filters: {
      data(val) {
        const date = new Date(val);
        const year = date.getFullYear();
        const month = date.getMonth();
        const day = date.getDate();
        return `${day.padStart(2, 0)}.${month.padStart(2, 0)}.${year}`
      }
    }
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

h2 {
  @include font-mixin(20px, 28px, 700, $style-black);

  span {
    display: block;
    margin-top: 10px;
    @include font-mixin(14px, 16px, 400, $style-black);
  }

  a {
    text-decoration: none;
    color: $blue-700;
  }
}

.details__params {
  margin-top: 20px;
}

.details__params-items {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
}

.details__params-item {
  margin-top: 20px;
  width: calc((100% - 40px) / 3);
}

.details__params-comment {
  margin-top: 20px;
}

.details__services {
  margin-top: 40px;
}

.details__services-item {
  margin-top: 40px;

  h3 {
    margin-bottom: 20px;
    @include font-mixin(16px, 20px, 700, $style-black);

    span {
      @include font-mixin(16px, 20px, 400, $gray-slate);
    }
  }
}

.table-block {
  @include font-mixin(12px, 12px, 400, $color-text-base);
  border: 1px solid $lavender;
  border-radius: 3px;
}

.table-block__header {
  display: flex;
  align-items: center;
  height: 60px;
  padding: 0 20px;
  background: $background-color-light;
  border-bottom: 1px solid $lavender;

  i {
    margin-right: 5px;
  }
}

::v-deep {
  textarea {
    height: 52px;
  }

  thead.fixed tr th {
    border-top: none;
  }

  tr:last-child {
    border-bottom: none;
  }
}

</style>